<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                template="/plantilla-principal.xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
        <f:metadata>
            <f:event type="preRenderView" listener="#{sessionManBean.modulosFuncionalidad(4)}"></f:event>
        </f:metadata>
        <style>
            #div-btn-elim{
                display: none;
            }
            #form-datos\:btn-modif{
                display: none;
            }
/*            div.scroll{
                height: 600px;
                overflow: auto;
            }*/
        </style>
        <h2 class="ui header">Funcionalidades</h2>
        <div class="ui secondary menu">
            <div class="fitted item">
                <div id="boton-nuevo" class="ui green button">
                    <i class="file icon" />
                    Nuevo
                </div>
            </div>
            <div id="div-btn-elim" class="fitted item">
                <div class="ui red button">
                    <i class="trash icon"/>
                    Eliminar
                </div>
            </div>
        </div>
        <div class="ui grid">
            <div class="eleven wide column">
                <div class="ui fluid icon input search">
                    <input id="txtBuscar" placeholder="Buscar" type="text"></input>
                    <i class="search icon"></i>
                </div>
                <div class="scroll" id="scroll">
                    <h:form id="form-tabla">
                        <table jsf:id="elementos-tabla" class="ui selectable celled table">
                            <thead>
                                <tr><th class="collapsing">
                                        <div  class="ui fitted checkbox" onclick="seleccionarTodo()">
                                            <input type="checkbox" id="chk-selec-todo"/>
                                            <label/>
                                        </div>
                                    </th>
                                    <th>ID</th>
                                    <th>Modulo</th>
                                    <th>Funcionalidad</th>
                                </tr>
                            </thead>
                            <tbody>

                                <ui:repeat value="#{funcionarioLoginManBean.funcionalidades}" var="funcionalidades" varStatus="funcionalidadesStatus">
                                    <tr id="fun#{funcionalidades.idfuncionalidad}">
                                        <td onclick="seleccionarFila('#{funcionalidades.idfuncionalidad}')"> 
                                            <div onclick="seleccionarCheck(#{funcionalidades.idfuncionalidad})" class="ui fitted checkbox">
                                                <input id="chk-fun-#{funcionalidades.idfuncionalidad}" type="checkbox" />
                                                <label></label>
                                            </div>
                                        </td>
                                        <td id="col-id-funcionalidad-#{funcionalidades.idfuncionalidad}" onclick="seleccionarFila('#{funcionalidades.idfuncionalidad}')">#{funcionalidades.idfuncionalidad}</td>
                                        <td id="col-modulo-funcionalidad-#{funcionalidades.idfuncionalidad}" onclick="seleccionarFila('#{funcionalidades.idfuncionalidad}')"><input id="col-idmodulo-#{funcionalidades.idfuncionalidad}" type="hidden" value="#{funcionalidades.modulo.idmodulo}" />#{funcionalidades.modulo.nombre}</td>
                                        <td id="col-nombre-funcionalidad-#{funcionalidades.idfuncionalidad}" onclick="seleccionarFila('#{funcionalidades.idfuncionalidad}')">#{funcionalidades.nombre}</td>
                                    </tr>
                                </ui:repeat>
                            </tbody>
                            <div id="dim-tabla" class="ui inverted dimmer"/>
                        </table>
                    </h:form>
                </div>
            </div>
            <div class="five wide column">
                <h:form id="form-datos">
                    <div class="ui form">
                        <div class="field">
                            <label>ID</label>
                            <input disabled="true" jsf:id="idfuncionalidad" name="idfuncionalidad" jsf:value="#{funcionarioLoginManBean.funcionalidadVar.idfuncionalidad}" placeholder="ID" type="0" readonly="true"></input>
                            <h:inputHidden id="idfuncionalidad-hidden" value="#{funcionarioLoginManBean.funcionalidadVar.idfuncionalidad}" />
                        </div>
                        <div class="field">
                            <label>Modulo</label>
                            <div id="modulofuncionalidad" class="ui search selection dropdown">
                                <input jsf:value="#{funcionarioLoginManBean.idFuncionalidadTmp}" type="hidden"/>
                                <i class="dropdown icon" />
                                <div class="default text">Modulo</div>
                                <div class="menu">
                                    <ui:repeat  value="#{moduloManbean.modulos}" var="modulos" varStatus="modulosStatus">
                                        <div class="item" data-value="#{modulos.idmodulo}">#{modulos.nombre}</div>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>
                        <div class="field">
                            <label>Funcionalidad</label>
                            <input jsf:id="nombrefuncionalidad" name="nombrefuncionalidad" jsf:value="#{funcionarioLoginManBean.funcionalidadVar.nombre}" placeholder="Funcionalidad" type="text"></input>
                        </div>
                        <div class="field">
                            <h:commandLink rendered="#{sessionManBean.permisosAsignados(8)}" id="btn-modif" class="ui teal button" action="#{funcionarioLoginManBean.editarFuncionalidad()}" >
                                <i class="save icon" />
                                Guardar
                                <f:ajax execute="@form" onevent="function (data) {
                                        if (data.status == 'success') {
                                        if ($('#msg-formulario').css('display') == 'none') {
                                        $('#msg-formulario').transition('fade');
                                        }
                                        }
                                        }" 
                                        render="text-formulario form-tabla"/>

                            </h:commandLink>
                            <h:commandLink rendered="#{sessionManBean.permisosAsignados(7)}" id="btn-agre" class="ui primary button" action="#{funcionarioLoginManBean.registrarFuncionalidad()}" >
                                <i class="add circle icon" />
                                Agregar
                                <f:ajax execute="@form" onevent="function (data) {
                                        if (data.status == 'success') {
                                        if ($('#msg-formulario').css('display') == 'none') {
                                        $('#msg-formulario').transition('fade');
                                        }
                                        }
                                        }" 
                                        render="text-formulario form-tabla"/>
                            </h:commandLink>
                        </div>
                        <div id="msg-formulario" class="ui info hidden message">
                            <i class="close icon" />
                            <div class="header">
                                Info
                            </div>
                            <h:outputText id="text-formulario" value="#{funManBean.msg}"/>
                        </div>
                    </div>
                </h:form>
            </div>
        </div>


            <h:form rendered="#{sessionManBean.permisosAsignados(9)}" id="dlg-conf-elim" class="ui basic modal">
                <input name="selbar" id="selbar" type="hidden" jsf:value="#{funcionarioLoginManBean.seleccionarIDfuncionalidadJSON}"/>
            <div class="ui icon header">
                <i class="trash icon"></i>
                Eliminar barrios
            </div>
            <div class="centered content">
                <p>¿Desea eliminar los elementos seleccionados?</p>
            </div>
            <div class="actions">
                <button jsf:action="#{funcionarioLoginManBean.eliminarFuncionalidad()}" class="ui green ok inverted button">
                    <i class="checkmark icon"></i>
                    Sí
                    <f:ajax execute="@form" onevent="generarDatos()" render="form-tabla"/>
                </button>

                <div class="ui red basic cancel inverted button">
                    <i class="remove icon"></i>
                    No
                </div>
            </div>
        </h:form>
            <script>
                 $('#form-datos\\:btn-modif').hide();
            $("#boton-nuevo").click(function (){
                $('#form-datos\\:btn-agre').show();
                $('#form-datos\\:btn-modif').hide();
                $('#form-datos\\:#div-btn-elim').hide();
                $('#form-datos\\:nombrefuncionalidad').focus();
                limpiarFormulario();
                removerCampoError();
            });
            
            $('#form-datos\\:btn-agre').click(function (){
                $('#form-datos\\:nombrefuncionalidad').focus();
                limpiarFormulario();
            });
            
            $('#form-datos\\:btn-modif').click(function  (){
                $('#form-datos\\:nombrefuncionalidad').focus();
                $('#form-datos\\:btn-modif').hide();
                $('#form-datos\\:btn-agre').show();
                $('#div-btn-elim').hide();
                limpiarFormulario();
            });
            
            $('#div-btn-elim').click(function () {
                $('#dlg-conf-elim').modal('show');
            });
            
            $('.message .close').on('click', function () {
                $(this).closest('.message').transition('fade');
            });
            
            function comprobarSeleccionTodo(){
                var seleccionados = $('tbody :checkbox:checked').length;
                var cantfila = $("tbody tr").length;
                if(seleccionados === 0){
                    $("#chk-selec-todo").prop("checked", false);
                }else{
                    if(seleccionados===cantfila){
                        $("#chk-selec-todo").prop("checked", true);
                    }else{
                        $("#chk-selec-todo").prop("checked", false);
                    }
                }
            }
            
            function ocultarBtnEliminarAndModifcar(){
                var seleccionado =$("tbody :checkbox:checked").length;
                if (seleccionado > 0) {
                    $("#div-btn-elim").show();
                    if (seleccionado===1) {
                        $('#form-datos\\:btn-modif').show();
                        $('#form-datos\\:btn-agre').hide();
                    }else{
                       $('#form-datos\\:btn-modif').hide();
                       $('#form-datos\\:btn-agre').show();
                    }
                }else{
                    $("#div-btn-elim").hide();
                    $('#form-datos\\:btn-modif').hide();
                    $('#form-datos\\:btn-agre').show();
                }
            }
            
            function seleccionarFila(idfuncionalidad){
                var idfila = '#fun' + idfuncionalidad;
                var idchk = '#chk-fun-' + idfuncionalidad;
                if($(idfila).hasClass('active')){
                    $(idfila).removeClass('active');
                    $(idchk).prop('checked', false);
                    limpiarFormulario();
                }else {
                    $(idfila).addClass('active');
                    $(idchk).prop('checked', true);
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificar(idfuncionalidad);
                removerCampoError();
            }
            
            function seleccionarCheck(idfuncionalidad){
                var idchk = '#chk-fun-' + idfuncionalidad;
                var idfila = '#fun' + idfuncionalidad;
                if($(idchk).prop('checked')){
                    $(idfila).removeClass("active");
                    limpiarFormulario();
                }else {
                    $(idfila).addClass('active');
                    $('#form-datos\\:nombrefuncionalidad').focus();
                }
                ocultarBtnEliminarAndModifcar();
                comprobarSeleccionTodo();
                modificar(idfuncionalidad);
                removerCampoError();
            }
            
            function seleccionarTodo(){
                if ($("#chk-selec-todo").prop("checked")) {
                    $("tbody tr").addClass("active");
                    $("tbody :checkbox").prop("checked", true);
                    $('#form-datos\\:btn-modif').hide();
                } else{
                    $("tbody tr").removeClass("active");
                    $("tbody :checkbox").prop("checked", false);
                    limpiarFormulario();
                }
                ocultarBtnEliminarAndModifcar();
            }
            
            function modificar(idfuncionalidad){
                $('#form-datos\\:idfuncionalidad').val($('#col-id-funcionalidad-'+idfuncionalidad).html());
                $('#form-datos\\:idfuncionalidad-hidden').val($('#col-id-funcionalidad-'+idfuncionalidad).html());
                $('#form-datos\\:nombrefuncionalidad').val($('#col-nombre-funcionalidad-'+idfuncionalidad).html());
                $('#form-datos\\:modulofuncionalidad').val($('#col-modulo-funcionalidad-'+idfuncionalidad).html());
//                col-modulo-funcionalidad-
                var idModuloSelec = parseInt($('#col-idmodulo-' + idfuncionalidad).val());
                $('#modulofuncionalidad').dropdown('set select', idModuloSelec);
            }
            
            function limpiarFormulario(){
                $('#form-datos\\:idfuncionalidad').val($().html());
                $('#form-datos\\:idfuncionalidad-hidden').val($().html());
                $('#form-datos\\:nombrefuncionalidad').val($().html());
            }
            function generarDatos(){
                var idSeleccionados=[];
                $("tbody tr [id^='col-id-funcionalidad']").each(function (index, value){
                   var id = parseInt($(this).html());
                   
                   if($('#chk-fun-'+id).prop('checked')){
                       idSeleccionados.push(id);
                   }
                });
                var jsonselect = JSON.stringify(idSeleccionados);
                $('#selbar').val(jsonselect);
                $('#div-btn-elim').hide();
            }
            
            $(document).ready(function(){
                $("#txtBuscar").keyup(function(){
                    if( $(this).val() !== ""){
			$("#form-tabla\\:elementos-tabla tbody>tr").hide();
			$("#form-tabla\\:elementos-tabla td:contains-ci('" + $(this).val() + "')").parent("tr").show();
                    }else{
			$("#form-tabla\\:elementos-tabla tbody>tr").show();
                    }
                });
            });
            $.extend($.expr[":"],{
                "contains-ci": function(elem, i, match, array){
                    return (elem.textContent || elem.innerText || $(elem).text() || "").toLowerCase().indexOf((match[3] || "").toLowerCase()) >= 0;
                }
            });
            </script>
    </ui:define>
</ui:composition>